/*
   This is the WTHS record thing for joel a.
	AUTHOR : Jovo John Filipovich (Engr. 1987 to 1990?)
	DATE : Start - October 2, 1989;  Finished - 
*/
CONSTANTS
  db_file_name      = "899LDAT.DBA"
  single_line_frame = "\218\191\192\217\196\179"  % single line frame
  double_line_frame = "\201\187\200\188\205\186"  % double line frame
  center_title      = -1                          % center the window title
  clear_window      = 1
  EDIT_TITLE        = " Editor "
  terminate         = "<< end of information >>"
  BLACK             = 0
  GRAY              = 8
  BLUE              = 1
  BRIGHT_BLUE       = 9
  GREEN             = 2
  BRIGHT_GREEN      = 10
  CYAN              = 3
  BRIGHT_CYAN       = 11
  RED               = 4
  BRIGHT_RED        = 12
  MAGENTA           = 5
  BRIGHT_MAGENTA    = 13
  BROWN             = 6
  YELLOW            = 14
  WHITE             = 7
  BRIGHT_WHITE      = 15
  B_BLACK           = 0
  B_BLUE            = 16
  B_GREEN           = 32
  B_CYAN            = 48
  B_RED             = 64
  B_MAGENTA         = 80
  B_BROWN           = 96
  B_WHITE           = 112
  BLINK             = 128

GLOBAL DOMAINS
  gs = STRING
  gsList = STRING*

  key = cr  ; esc; break; tab ; btab ; del  ;
        bdel; ins; end  ; home; num(INTEGER);
        fkey(INTEGER); up; down; left; right;
        char(CHAR)   ; pgup ; pgdn   ; other ;
        ctrl_bdel
  keylist, ValidKeyPress = key*


GLOBAL DATABASE
  category(gs).    % Like METAL or PROGRESSIVE
  label(gsList,gs,gsList,gs,gs,gs,gs,gsList)
  % label (Category,ContactName,AddressInfo,City,State,Zip,Comments)
  determ datamodified    % Exists if data was modified
  
GLOBAL PREDICATES
  determ    openbase                               % Opens and reads the database into memory
  determ    clbase                                 % Closes the database
  nondeterm repeat                                 % The Repeat clause
  determ    up_case(CHAR,CHAR)           - (i,o)   % Converts a char to upper case
  determ    wait                                   % waits for user to press enter
  determ    getkey(key,keylist)          - (o,i)   % This is what the program uses for kbd
  determ    readkey(key)                 - (o)     % Reads a key press and returns the key
  determ    change_window_title(STRING)  - (i)     % Change window to this title
  determ    inverse(INTEGER,INTEGER)     - (i,o)   % Reverse video attributes
  determ    getMusicTypes(gsList)        - (o)     % Gets the list of all music types
  determ    getLabelNames(gsList)        - (o)     % Gets all the label names
  determ    showerr(STRING)              - (i)     % Makes an error window and delays
  determ    message(STRING)              - (i)     % Prints message and leaves
  nondeterm getIntOpt(INTEGER,INTEGER,INTEGER) - (i,i,o) % Gets an integer option
  determ    writeToEol(CHAR)             - (i)
  determ    askyn                                  % Fails on N, succeeds on Y
  determ    bep                                    % Beeps a new beep
  determ    getCorrelating(gs,gsList)    - (i,o) % for given type, get list of names
  nondeterm show_get(gsList,gs,gs)       - (i,o,i) % Screen get/show -- W title
  determ    maxlen(gsList,INTEGER,INTEGER) - (i,i,o) % Finds the longest string length in a list
  determ    listlen(gsList,INTEGER)      - (i,o)   % Number of items in list
  determ    expgsList(gs,gsList,gsList)  - (i,i,o) % Deletes from list to new list
  determ    modifdat                               % Modify Data
  nondeterm edit_setup(gsList,gs)        - (i,i)   % Comments edit setup and sets title
  determ    edit_setdown(gsList)         - (o)     % Comments edit destructive kill
  determ    edit_retrieve(gsList)        - (o)     % Comments retrieve (nondestructive)
  nondeterm edit_descr                             % the main editor which assumes things are set up
  determ    modspecs(dbasedom,dbasedom)  - (i,o)   % Modifies or created new DB objects
  determ    sameMusicCategory(gs,gsList) - (i,i)   % test for same
  determ    writelist(gsList,INTEGER)    - (i,i)   % Write's each elem to stdout indenting
  determ    writespaces(INTEGER)         - (i)     % Spaces to stdout
  determ    sheet_print                            % Prints a simple list of database
  determ    label_print                            % Prints DB as labels
  determ    fixup(gs,gs)                 - (i,o)   language asm
